#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <stdio.h>

void showthetime(GtkWidget *);
void display_popup(void);
void show_about_window(void);

extern GtkWidget *menu1;
extern GtkWidget *TubeClock;
extern int windowed,half_size, prevmin, twentyfourhourmode,adebug;

void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_main_quit();
}





void
on_fixed1_notify                       (GObject         *gobject,
                                        gpointer         user_data)
{
  showthetime(GTK_WIDGET(gobject));

}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  show_about_window();
}




gboolean
on_TubeClock_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  display_popup();
 return 0;
}


void
on_half_size1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *half_size1 = 
    lookup_widget(GTK_WIDGET(menuitem), "half_size1");
  if ( gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(half_size1))) {
    if ( adebug ) {
      printf("Half size active\n");
    }
    half_size=1;
    prevmin = -1;
  } else {
    if (adebug) {
      printf("Half size not active\n");
    }
    half_size=0;
    prevmin = -1;
  }
}





void
on_do24hour_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *do24hour = 
    lookup_widget(GTK_WIDGET(menuitem), "do24hour");
  if ( gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(do24hour))) {
    if (adebug) {
      printf("24-hour mode active\n");
    }
    twentyfourhourmode=1;
    prevmin = -1;
  } else {
    if (adebug) {
    printf("24-hour mode not active\n");
    }
    twentyfourhourmode=0;
    prevmin = -1;
  }

}




void
on_show_borders1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *show_borders1 = 
    lookup_widget(GTK_WIDGET(menuitem), "show_borders1");
  if ( gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(show_borders1))) {
    if (adebug) {
      printf("windowed mode active\n");
    }
    if ( TubeClock->window != NULL) {
      gdk_window_hide(TubeClock->window);
      gdk_window_set_decorations(GDK_WINDOW(TubeClock->window), GDK_DECOR_ALL);
      gdk_window_show(TubeClock->window);
    }
    windowed=1;
    prevmin = -1;
  } else {
    if (adebug) {
    printf("windowed mode not active\n");
    }
    gdk_window_hide(TubeClock->window);
    gdk_window_set_decorations(GDK_WINDOW(TubeClock->window), 0);
    gdk_window_show(TubeClock->window);
    windowed=0;
    prevmin = -1;
  }
}


void
on_move_window1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  /* this is kind of hacky. But it seems that the below will work
     once we have toggled windowed mode on  (but only in sawfish) 
     so, if it is off, we'll toggle it on then off first. This 
     moves the window around though */

  if ( !windowed ) {
        gdk_window_hide(TubeClock->window);
    gdk_window_set_decorations(GDK_WINDOW(TubeClock->window), GDK_DECOR_ALL);
    gdk_window_set_decorations(GDK_WINDOW(TubeClock->window), 0);
    gdk_window_show(TubeClock->window);
  }
  
  gdk_window_begin_move_drag(TubeClock->window, 0,0,0,0);
}


void
on_TubeClock_drag_begin                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data)
{

}



