/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"

/* these includes probably need to be configure-ized to be
   more platform-neutral */

#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>

/* probably a lot of this stuff should be moved into header files.
   Also I want to try to reduce global variables */

void listthelooks(void);
void loadlook(char *);
void loadtheimages(void);
void showthetime(GtkWidget *, int, int, int, int, int);
int update_time(GtkWidget *);
GdkPixbuf *get_pixbuf_from_image_dir(char *);
static void session_die(GnomeClient *, gpointer);
static gint save_session(GnomeClient *, gint, GnomeSaveStyle,
			 gint, GnomeInteractStyle, gint, gpointer);

int min1x, min1y, min2x, min2y, hour1x, hour1y, hour2x, hour2y;
int ampm, ampmx, ampmy;
int height, width;
int scaled, reflection;
int listlooks;
static char* look=NULL;
char looktoload[255];
int draw_leading_zero; /* only for 12 hour mode */
int have_background_mask_scaled=0;
int half_size=0;
int prevmin=-1, digittoshow= 0;
GdkPixbuf *d[10], *background_pixbuf, *background_pixbuf_blank;
GdkPixbuf *background_pixbuf_blank_scaled;
GdkPixbuf *reflection_pixbuf;
GdkColormap *colormap;
GdkDrawable *background_drawable ;
GdkPixbuf *background_pixbuf_scaled;
GdkPixmap *background_pixmap;
GdkBitmap *background_mask_scaled, *background_mask;
GdkGC *background_gc;
GtkWidget *TubeClock,*fixed1;
GtkWidget *menu1;
static unsigned char bmap_bits[] = { 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff}; 
static unsigned char bmap_bits_small[] = { 
  0xff};
int twentyfourhourmode=0,twelvehourmode=0;
int adebug;
int windowed=0;
char image_dir[1024];
GdkPixbuf *am_pixbuf, *pm_pixbuf;
gchar *look_author, *look_description;

#include "options.h"

int
main (int argc, char *argv[])
{
  GnomeClient *client;


  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
		      GNOME_PARAM_POPT_TABLE, options,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);

  /* before doing anything, we might as well see if they just want some
     info.  This is kind of annoying, because it requires a valid
     DISPLAY, even though we're not going to display anything --
     but we have to do this after the gnome_program_init so that the
     arguments have been parsed for us */

  if ( listlooks ) {
    listthelooks();
    /* is this the best way to exit at this point? Can't do gtk_main_quit
       because we're not in the main loop yet. */
    exit(0);
  }

  if ( look==NULL ) {
    strcpy(looktoload, "tubeclock");
    
  } else {
    strncpy(looktoload, look, sizeof(looktoload));
  }

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

  TubeClock = create_TubeClock ();
  menu1 = create_menu1();

  loadlook(looktoload);

  /* set options here. default on check boxes is off (making them
     default to 'on' wasn't working too well */

  /* kind of ugly, but want to be able to specify 24-hour mode on the command
     line even though it's the default */

  if ( twelvehourmode && twentyfourhourmode ) {
    twelvehourmode=0;
    twentyfourhourmode=1;
  }
  if (!twelvehourmode) {
    twentyfourhourmode=1;
  }

  if ( adebug) {
  printf("Options: 24-hour mode=%d, half size=%d\n",twentyfourhourmode,
	 half_size);
  }
  gtk_check_menu_item_set_active(
     GTK_CHECK_MENU_ITEM(lookup_widget(GTK_WIDGET(menu1),"do24hour")), 
        (twentyfourhourmode==1));
  gtk_check_menu_item_set_active(
     GTK_CHECK_MENU_ITEM(lookup_widget(GTK_WIDGET(menu1),"half_size1")), 
        (half_size==1));
  gtk_check_menu_item_set_active(
     GTK_CHECK_MENU_ITEM(lookup_widget(GTK_WIDGET(menu1),"show_borders1")), 
        (windowed==1));



  /* set up session management callbacks */

  client = gnome_master_client();
  gtk_signal_connect(GTK_OBJECT (client), "save_yourself",
                      GTK_SIGNAL_FUNC (save_session), argv[0]);
  gtk_signal_connect (GTK_OBJECT (client), "die",
                      GTK_SIGNAL_FUNC (session_die), NULL);




  gtk_widget_show (TubeClock);

  /* turn off window manager border. */
  /* the hide/show business is needed for sawfish, maybe some others. */
  
  if ( !windowed) {
    gdk_window_hide(GDK_WINDOW(TubeClock->window));
    gdk_window_set_decorations(GDK_WINDOW(TubeClock->window), 0);
    gdk_window_show(GDK_WINDOW(TubeClock->window));
  }
  

  colormap=gdk_colormap_get_system();
  loadtheimages();

  /* create the empty pixbuf for the half-size image */
  if ( scaled ) {
    background_pixbuf_scaled = gdk_pixbuf_new(GDK_COLORSPACE_RGB, TRUE,
					      8, width, height);
  }

  /* create the drawable... */
	background_drawable=gdk_pixmap_new(TubeClock->window, width,height, -1);
	/* now fill it in with something recognizable. */

	/* get the initial graphcs context */
  background_gc = gdk_gc_new (background_drawable);
  
  /*  gdk_gc_set_clip_mask(background_gc, background_mask); */

  /* gdk_draw_rectangle(background_drawable, background_gc,
		     TRUE, 0, 0, width,height);
  */

  update_time(TubeClock);
  g_timeout_add(900, (GSourceFunc)&update_time, TubeClock);

gtk_main (); 

  return 0;
}

int update_time(GtkWidget *window) {
  int hour, min, pm;
  time_t t;
  struct tm *thetime;

    time(&t);
    thetime = localtime(&t);
    
    hour=thetime->tm_hour;
    min=thetime->tm_min;
    pm = (hour >= 12);

    if ( ( ! twentyfourhourmode) && (hour == 0 )) {
      hour = 12;
    }
    if ( (! twentyfourhourmode) && (hour > 12 )) {
      hour -= 12;
    }
    
    if (adebug) {
      printf("update_time called; hour= %d, min=%d, prevmin=%d\n", hour, min, prevmin); 
    }
    if (  min != prevmin ) { 
      
	showthetime(window, hour/10, hour-(hour/10)*10,
		    min/10, min-(min/10)*10, pm);
      prevmin = min;
      if (adebug) {
	printf("returned from showthetime\n");
      }
    }
    return TRUE;
    
}

/* showthetime: displays the indicated digits in the clock */

void showthetime(GtkWidget *window, int digit1, int digit2, int digit3, int digit4, int pm) {
  GtkWidget *background = lookup_widget(GTK_WIDGET(window), "background");


      /* create a pixmap and mask bitmap out of the blank background */

      gdk_pixbuf_render_pixmap_and_mask ( background_pixbuf_blank,
					  &background_drawable,
					  &background_mask,
					  128 );
      
      /* draw the digits */

      gdk_draw_pixbuf(background_drawable, NULL, d[digit4],
		      0, 0, min2x,min2y,
		      -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      gdk_draw_pixbuf(background_drawable, NULL, d[digit3],
		      0, 0, min1x,min1y,
		      -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      gdk_draw_pixbuf(background_drawable, NULL, d[digit2],
		      0, 0, hour2x,hour2y,
		      -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      /* only draw the leading zero if specified in config */
      if ( digit1 || draw_leading_zero )
      gdk_draw_pixbuf(background_drawable, NULL, d[digit1],
		      0, 0, hour1x,hour1y,
		      -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      /* may be able to draw the reflection once into the blank background,
       but for now it's here */
      if ( reflection ) {
	gdk_draw_pixbuf(background_drawable, NULL, reflection_pixbuf,
			0, 0, 0, 0, -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      }
      
      /* draw am/pm indicators if appropriate */

      if ( ampm ) {
	if ( !twentyfourhourmode ) {
	  if (pm ) { 
	    gdk_draw_pixbuf(background_drawable, NULL, pm_pixbuf,
			    0, 0, ampmx, ampmy,
			    -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
	  } else {
	    gdk_draw_pixbuf(background_drawable, NULL, am_pixbuf,
			    0, 0, ampmx, ampmy,
			    -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
	  }
	}
      }

      /* make the half-size pixbuf if needed */

      if ( half_size ) {


	/* put the completed drawable into pixbuf so we can scale it */
	if (scaled) {
	  gdk_pixbuf_get_from_drawable(background_pixbuf, background_drawable,
				       colormap, 0, 0, 0, 0, width,height);
	  
	  /* this one doesn't work quite right (image is offset)
	     background_pixbuf_scaled=gdk_pixbuf_scale_simple(
	     background_pixbuf,
	     width/2, height/2, GDK_INTERP_NEAREST);
	  */
	  
	  gdk_pixbuf_scale( background_pixbuf, background_pixbuf_scaled,
			    0, 0, width/2, height/2, 0.0, 0.0, 
			    .5, .5, GDK_INTERP_BILINEAR);
	  

	/* put the half-size stuff back into the pixmap (drawable) */
	/* We will actually not use the pixmap, just the mask. 
	   Maybe we could just render_alpha to create the mask, but
	   this seems to work best. */

	/* for some reason, the following render_pixmap_and_mask
	   causes a lot of memory to be sucked up if executed repeatedly.
	   we already unref background_drawable. unref-ing 
	   background_mask_scaled does not do the trick. unref-ing
	   background_pixbuf_blank_scaled is bad. So, as a workaround,
	   we will only do it once. */

	  if ( !have_background_mask_scaled ) {
	    gdk_pixbuf_render_pixmap_and_mask ( background_pixbuf_blank_scaled,
						&background_drawable,
						&background_mask_scaled,
						128 );
	    have_background_mask_scaled = 1;
	    if ( adebug ) {
	      printf("rendering half-size mask\n");
	    }
	  }
	  
	  gtk_image_set_from_pixbuf(GTK_IMAGE(background), 
				    background_pixbuf_scaled);
	  
	  if ( !windowed) {
	    gtk_widget_shape_combine_mask(TubeClock, background_mask_scaled, 0, 0);
	  }
	}
      } else {
	
	/* now put the pixmap back to the image */
	
	gtk_image_set_from_pixmap(GTK_IMAGE(background), background_drawable,
				  background_mask);
	if ( !windowed) {
	  gtk_widget_shape_combine_mask(TubeClock, background_mask, 0, 0);
	}
      }
      /* now we're done with the drawables, unref them to free up mem */
      g_object_unref(background_drawable);
      /* if the background has no alpha channel then the background
	 mask will be NULL, so don't try to free it again. */
      if ( background_mask != NULL ) {
	g_object_unref(background_mask);
      }
}

void loadtheimages() {

  int i;

 char filename[13];
  
  for ( i=0; i<10; i++ ) {
    g_snprintf(filename, 12, "1-%d.png", i);
    d[i]= get_pixbuf_from_image_dir(filename);
  }

 
  /* load the background into two pixbufs. One will be the working
     image, the other will be the clean background. */

  background_pixbuf=get_pixbuf_from_image_dir("Background.png");
  background_pixbuf_blank=get_pixbuf_from_image_dir("Background.png");
  if (scaled ) {
    background_pixbuf_blank_scaled=get_pixbuf_from_image_dir("Background-scaled.png");
  }
  if (reflection) {
  reflection_pixbuf=get_pixbuf_from_image_dir("Reflection.png");
  }
  if (ampm) {
    am_pixbuf=get_pixbuf_from_image_dir("AM.png");
    pm_pixbuf=get_pixbuf_from_image_dir("PM.png");
  }
  
  /* create the mask (blank) */

  background_mask=gdk_bitmap_create_from_data(NULL, bmap_bits, width, height);
  if (scaled) {
    background_mask_scaled=gdk_bitmap_create_from_data(NULL, bmap_bits_small, width/2, height/2);
  }
}


void display_popup() {

  gtk_menu_popup(GTK_MENU(menu1), NULL, NULL, NULL, NULL,0, 
		 gtk_get_current_event_time());
} 

void show_about_window() {
  GtkWidget *about;
  gchar look_author_string[128];
  gchar description_string[256];
  const gchar *authors[] = {
    "Andrew Tefft <gtubeclock @ bonnyswan.com>",
    look_author_string,
    NULL
  };
  g_snprintf(look_author_string, 127, "%s (artwork)", look_author);

  g_snprintf(description_string, 255, "A nixie tube clock for GNOME\n\nconfig file: "PACKAGE_DATA_DIR"/gtubeclock/gtubeclock.settings\nartwork: %s -- %s\nartwork location: "PACKAGE_DATA_DIR"/"PACKAGE"/pixmaps/%s", looktoload, look_description,looktoload);

  about = gnome_about_new("gtubeclock", VERSION,
			  "(C) 2004 Andrew Tefft",
			  description_string,
			  authors,
			  NULL, NULL,
			  NULL);
  /* can't make it modal since in gnome 2.x, the "about" window
     has a "credits" sub-window, and you won't be able to dismiss that
     if the about window is modal. */

  /*  gtk_window_set_modal(GTK_WINDOW(about), TRUE); */
  gtk_widget_show(about);
}



static void session_die(GnomeClient *client, gpointer client_data) {
  gtk_main_quit();
}

static gint save_session (GnomeClient *client, gint phase, 
			  GnomeSaveStyle save_style,
              gint is_shutdown, GnomeInteractStyle interact_style,
              gint is_fast, gpointer client_data)
{
  gchar* argv[6]; /* make sure this is big enough to hold all the possible
		     arguments we will store */
  guint argc;

  argc = 1;

  argv[0] = client_data;

  if ( adebug ) {
    printf("debug=1, 12hour=%d, halfsize=%d, windowed=%d\n",
	   !twentyfourhourmode, half_size, windowed);
    argv[argc++] = "-d";
  }
  if (!twentyfourhourmode)
    {
      argv[argc++] = "--12hour";
    }
  if ( half_size ) 
    {
      argv[argc++] = "--halfsize";
    }      
  if ( windowed ) 
    {
      argv[argc++] = "--windowed";
    }      
  argv[argc++] = "-l";
  argv[argc++] = looktoload;
  argv[argc]=NULL;

  gnome_client_set_clone_command (client, argc, argv);
  gnome_client_set_restart_command (client, argc, argv);

  return TRUE;
}


/* get the parameters from the config file based on which look we're using */

void loadlook(char *looktoload) {
  char prefix[1024];

  g_snprintf(prefix,1023 ,"="PACKAGE_DATA_DIR"/gtubeclock/gtubeclock.settings=/%s/", looktoload);
  if ( adebug ) {
    printf("gnome_config prefix=%s\n", prefix);
  }

    gnome_config_push_prefix(prefix);

    if (adebug) {
      
      printf("configuration section name=%s\n",
	     gnome_config_get_string("name"));
    }
    
    hour1x= gnome_config_get_int("hour1x=0");
    hour1y= gnome_config_get_int("hour1y=0");
    hour2x= gnome_config_get_int("hour2x=0");
    hour2y= gnome_config_get_int("hour2y=0");
    min1x= gnome_config_get_int("min1x=0");
    min1y= gnome_config_get_int("min1y=0");
    min2x= gnome_config_get_int("min2x=0");
    min2y= gnome_config_get_int("min2y=0");

    height=gnome_config_get_int("height=100");
    width=gnome_config_get_int("width=100");

    scaled=gnome_config_get_bool( "scaled=false" );
    reflection=gnome_config_get_bool("reflection=false");
    draw_leading_zero=gnome_config_get_bool("leadingzero=false");
    ampm=gnome_config_get_bool("ampm=false");
    if ( ampm ) {
      ampmx=gnome_config_get_int("ampmx=0");
      ampmy=gnome_config_get_int("ampmy=0");
    }
    look_author=gnome_config_get_string("author=default artwork author");
    look_description=gnome_config_get_string("description=default artwork description");
}

GdkPixbuf *get_pixbuf_from_image_dir(char *filetoload) {
  char path[255];
  
  g_snprintf(path, 254, PACKAGE_DATA_DIR"/"PACKAGE"/pixmaps/%s/%s",
	     looktoload, filetoload);

  if ( adebug ) {
    printf("Loading file %s\n", path);
  }

  return gdk_pixbuf_new_from_file(path, NULL);
}

void listthelooks() {
  char prefix[1024], bigprefix[1024];
  gpointer config_iterator;
  gchar *key,*value;


  g_snprintf(prefix,1023 ,"="PACKAGE_DATA_DIR"/gtubeclock/gtubeclock.settings=");
  if ( adebug ) {
    printf("gnome_config prefix=%s\n", prefix);
  }

  printf("The following configurations are defined in\n" PACKAGE_DATA_DIR "/gtubeclock/gtubeclock.settings.\n");
  printf("You can choose one with -l or --look=LOOK.\n\n");
  config_iterator = gnome_config_init_iterator_sections(prefix);

  while ((config_iterator=gnome_config_iterator_next(config_iterator, &key, NULL)))  {
    printf("%s \t",key);
    g_snprintf(bigprefix, 1023, "%s/%s/description=no description available", 
	       prefix,key);
    if (adebug) {
      printf ("[bigprefix=%s]",bigprefix);
    }
    printf(gnome_config_get_string(bigprefix));
    printf("\n");
  }
  
}

